## dune-istl 2.3.1

=== dune/istl/CMakeLists.txt ===
add_subdirectory("paamg")
add_subdirectory("tutorial")
add_subdirectory("test" EXCLUDE_FROM_ALL)

#install headers
install(FILES
   basearray.hh
   bcrsmatrix.hh
   bdmatrix.hh
   btdmatrix.hh
   bvector.hh
   colcompmatrix.hh
   diagonalmatrix.hh
   gsetc.hh
   ilu.hh
   ilusubdomainsolver.hh
   io.hh
   istlexception.hh
   matrix.hh
   matrixindexset.hh
   matrixmarket.hh
   matrixmatrix.hh
   matrixredistribute.hh
   matrixutils.hh
   multitypeblockmatrix.hh
   multitypeblockvector.hh
   novlpschwarz.hh
   operators.hh
   overlappingschwarz.hh
   owneroverlapcopy.hh
   pardiso.hh
   preconditioner.hh
   preconditioners.hh
   repartition.hh
   scalarproducts.hh
   scaledidmatrix.hh
   schwarz.hh
   solvercategory.hh
   solver.hh
   solvers.hh
   solvertype.hh
   superlu.hh
   supermatrix.hh
   umfpack.hh
   vbvector.hh
   DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/istl)

=== dune/istl/test/CMakeLists.txt ===
set(NORMALTEST
  basearraytest
  bvectortest
  bcrsbuildtest
  bcrsimplicitbuildtest
  dotproducttest
  iotest
  inverseoperator2prectest
  matrixiteratortest
  matrixtest
  matrixutilstest
  mmtest
  mv
  scaledidmatrixtest
  seqmatrixmarkettest
  vbvectortest)

if(HAVE_PARDISO)
  set(PARDISOTEST test_pardiso)
endif(HAVE_PARDISO)

if(SUPERLU_FOUND)
  set(SUPERLUTESTS
  complexrhstest superlutest superluztest superluctest superlustest
  )
endif(SUPERLU_FOUND)

if(UMFPACK_FOUND)
  set(UMFPACKTESTS umfpacktest)
endif()

if ((SUPERLU_FOUND) OR (UMFPACK_FOUND))
  set(OVLPSCHWARZTESTS overlappingschwarztest)
endif()

if(HAVE_MPI)
  set(MPITESTS vectorcommtest matrixmarkettest matrixredisttest)
endif(HAVE_MPI)

set(ALLTESTS ${MPITESTS} ${NORMALTEST} ${PARDISOTEST} ${SUPERLUTESTS} ${UMFPACKTESTS} ${OVLPSCHWARZTESTS})


# We do not want want to build the tests during make all,
# but just build them on demand
add_directory_test_target(_test_target)
add_dependencies(${_test_target} ${ALLTESTS})


include(DuneMPI)

# Provide source files
add_executable(basearraytest "basearraytest.cc")
add_executable(dotproducttest "dotproducttest.cc")
add_executable(matrixutilstest "matrixutilstest.cc")
add_executable(matrixtest "matrixtest.cc")
add_executable(bvectortest "bvectortest.cc")
add_executable(vbvectortest "vbvectortest.cc")
add_executable(bcrsbuildtest "bcrsbuild.cc")
add_executable(bcrsimplicitbuildtest "bcrsimplicitbuild.cc")
set_property(TARGET bcrsimplicitbuildtest APPEND PROPERTY COMPILE_DEFINITIONS "DUNE_ISTL_WITH_CHECKING=1")
add_executable(matrixiteratortest "matrixiteratortest.cc")
add_executable(mmtest mmtest.cc)
add_executable(mv "mv.cc")
add_executable(iotest "iotest.cc")
add_executable(inverseoperator2prectest "inverseoperator2prectest.cc")
add_executable(scaledidmatrixtest "scaledidmatrixtest.cc")
add_executable(seqmatrixmarkettest "matrixmarkettest.cc")
#set_target_properties(seqmatrixmarkettest PROPERTIES COMPILE_FLAGS
#  "-DMMSEQUENTIAL ${MPI_DUNE_COMPILE_FLAGS} -DENABLE_MPI=1 -DMPICH_SKIP_MPICXX -DMPIPP_H")

if(HAVE_PARDISO)
  add_executable(pardiso_test test_pardiso.cc)

  # TODO add pardiso flags
endif(HAVE_PARDISO)

if(SUPERLU_FOUND)
  add_executable(complexrhstest complexrhstest.cc)
  set_property(TARGET complexrhstest APPEND PROPERTY COMPILE_DEFINITIONS "SUPERLU_NTYPE=3")

  add_executable(superlutest "superlutest.cc")

  add_executable(superlustest "superlutest.cc")
  set_property(TARGET superlustest APPEND PROPERTY COMPILE_DEFINITIONS "SUPERLU_NTYPE=0")

  add_executable(superluctest "superlutest.cc")
  set_property(TARGET superluctest APPEND PROPERTY COMPILE_DEFINITIONS "SUPERLU_NTYPE=2")

  add_executable(superluztest "superlutest.cc")
  set_property(TARGET superluztest APPEND PROPERTY COMPILE_DEFINITIONS "SUPERLU_NTYPE=3")

  add_dune_superlu_flags("${SUPERLUTESTS}")
endif(SUPERLU_FOUND)

if(UMFPACK_FOUND)
  add_executable(umfpacktest umfpacktest.cc)
  add_dune_umfpack_flags(umfpacktest)
  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "umfpack_decomp")
endif()

if ((SUPERLU_FOUND) OR (UMFPACK_FOUND))
  add_executable(overlappingschwarztest "overlappingschwarztest.cc")
  if (SUPERLU_FOUND)
    add_dune_superlu_flags(overlappingschwarztest)
  endif()
  if (UMFPACK_FOUND)
    add_dune_umfpack_flags(overlappingschwarztest)
  endif()
endif()

if(HAVE_MPI)
  add_executable(matrixredisttest "matrixredisttest.cc")
  add_executable(vectorcommtest "vectorcommtest.cc")
  add_executable(matrixmarkettest "matrixmarkettest.cc")
  add_dune_mpi_flags("${MPITESTS}")
  add_dune_parmetis_flags(matrixredisttest)
endif(HAVE_MPI)

foreach(_exe ${ALLTESTS})
  target_link_libraries(${_exe} "dunecommon")
  add_test(${_exe} ${_exe})
endforeach(_exe ${ALLTESTS})

## dune-istl 2.2~svn1538

=== debian/changelog ===
dune-istl (2.2~svn1538-1) experimental; urgency=low

  * Initial release. (Closes: #661823)

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 17 Mar 2012 17:20:16 +0100

=== debian/control ===
Source: dune-istl
Section: libs
Priority: optional
Standards-Version: 3.9.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/dune-istl.git
Vcs-Git: git://git.debian.org/debian-science/packages/dune-istl.git
Homepage: http://www.dune-project.org/
Build-Depends: debhelper (>= 9),
 automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
 libdune-common-dev (>= 2.2~)
Build-Depends-Indep: doxygen, ghostscript, texlive-latex-extra, texlive-latex-recommended, pgf

Package: libdune-istl-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, libdune-common-dev (>= 2.2~)
Pre-Depends: dpkg (>= 1.15.6)
Description: toolbox for solving PDEs -- iterative solvers (development files)
 DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
 for solving partial differential equations (PDEs) with grid-based methods.
 It supports the easy implementation of methods like Finite Elements (FE),
 Finite Volumes (FV), and also Finite Differences (FD).
 .
 This package contains the development files for the iterative solver template
 library.

Package: libdune-istl-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Description: toolbox for solving PDEs -- iterative solvers (documentation)
 DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
 for solving partial differential equations (PDEs) with grid-based methods.
 It supports the easy implementation of methods like Finite Elements (FE),
 Finite Volumes (FV), and also Finite Differences (FD).
 .
 This package contains the documentation for the iterative solver template
 library.

## dune-istl 2.2.0

=== debian/changelog ===
dune-istl (2.2.0-1) unstable; urgency=low

  * New upstream release.

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 05 Jun 2012 10:31:10 +0200

dune-istl (2.2~svn1573-1) experimental; urgency=low

  * New upstream snapshot.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 06 May 2012 15:27:20 +0200

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,13 @@
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
  automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
- libdune-common-dev (>= 2.2~)
+ libdune-common-dev (>= 2.2.0)
 Build-Depends-Indep: doxygen, ghostscript, texlive-latex-extra, texlive-latex-recommended, pgf
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.2~)
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.2.0)
 Pre-Depends: dpkg (>= 1.15.6)
 Description: toolbox for solving PDEs -- iterative solvers (development files)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox

## dune-istl 2.2.1

=== debian/changelog ===
dune-istl (2.2.1-2) unstable; urgency=low

  * Upload to unstable.
  * Bumped Standards-Version to 3.9.4 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 18 May 2013 13:38:00 +0200

dune-istl (2.2.1-1) experimental; urgency=low

  * debian/copyright: Update for new upstream release.

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 02 Mar 2013 03:04:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: dune-istl
 Section: libs
 Priority: optional
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/dune-istl.git
@@ -9,13 +9,13 @@
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
  automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
- libdune-common-dev (>= 2.2.0)
+ libdune-common-dev (>= 2.2.1)
 Build-Depends-Indep: doxygen, ghostscript, texlive-latex-extra, texlive-latex-recommended, pgf
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.2.0)
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.2.1)
 Pre-Depends: dpkg (>= 1.15.6)
 Description: toolbox for solving PDEs -- iterative solvers (development files)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dune/dune-debian.mk
DUNE_DEBIAN_CONFIGURE_FLAGS += --libdir='$${prefix}/lib'

%:
	dh $@ --parallel

## dune-istl 2.3.1

=== debian/changelog ===
dune-istl (2.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 17 Jun 2014 19:59:56 +0200

dune-istl (2.3.1~rc1-1) experimental; urgency=medium

  * New upstream release candidate.

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 10 Jun 2014 20:47:18 +0200

dune-istl (2.3.0-1) unstable; urgency=medium

  * New upstream release.
  * libdune-istl-dev.install: Install /usr/share/dune-istl.

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 14 Feb 2014 09:40:54 +0100

dune-istl (2.3~20140117g08c9a059-1) experimental; urgency=medium

  * New upstream snapshot.
  * libdune-istl-dev.install: Install /usr/lib/cmake.

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 20 Jan 2014 22:55:52 +0100

dune-istl (2.3~20140110beta1-1) experimental; urgency=medium

  * New upstream snapshot.

 -- Ansgar Burchardt <ansgar@debian.org>  Wed, 15 Jan 2014 13:45:19 +0100

dune-istl (2.3~20131228ge5739c8-1) experimental; urgency=medium

  * New upstream snapshot.
  * Bumped Standards-Version to 3.9.5.
  * Drop pre-depends on dpkg (>= 1.15.6) which is already satisfied in
    Debian 6.
  * debian/control: Use canonical Vcs-* URIs.

 -- Ansgar Burchardt <ansgar@debian.org>  Wed, 01 Jan 2014 19:55:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,21 @@
 Source: dune-istl
 Section: libs
 Priority: optional
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
-Vcs-Browser: http://git.debian.org/?p=debian-science/packages/dune-istl.git
-Vcs-Git: git://git.debian.org/debian-science/packages/dune-istl.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/dune-istl.git
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/dune-istl.git
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
  automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
- libdune-common-dev (>= 2.2.1)
+ libdune-common-dev (>= 2.3.1)
 Build-Depends-Indep: doxygen, ghostscript, texlive-latex-extra, texlive-latex-recommended, pgf
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.2.1)
-Pre-Depends: dpkg (>= 1.15.6)
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.3.1)
 Description: toolbox for solving PDEs -- iterative solvers (development files)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
  for solving partial differential equations (PDEs) with grid-based methods.
@@ -30,7 +29,6 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Pre-Depends: dpkg (>= 1.15.6)
 Description: toolbox for solving PDEs -- iterative solvers (documentation)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
  for solving partial differential equations (PDEs) with grid-based methods.

## dune-istl 2.4.0

=== debian/changelog ===
dune-istl (2.4.0-1) unstable; urgency=medium

  * New upstream release.
  * (Build-)Depend on last dune-common upload.

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 25 Sep 2015 22:39:59 +0200

dune-istl (2.4~20150912rc3-1) unstable; urgency=medium

  * New upstream release candidate.
  * Add (build-)dep on libsuitesparse-dev to enable UMFPack support.
  * (Build-)Depend on last dune-common upload.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 13 Sep 2015 13:55:32 +0200

dune-istl (2.4~20150825rc2-1) experimental; urgency=medium

  * New upstream release candidate.
  * (Build-)Depend on last dune-common upload.

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 04 Sep 2015 16:13:45 +0200

dune-istl (2.4~20150717rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * (Build-)Depend on last dune-common upload.

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 17 Jul 2015 21:09:18 +0200

dune-istl (2.4~20150610g6e80ced-1) experimental; urgency=medium

  * New upstream snapshot.
  * (Build-)Depend on last dune-common upload.

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 20 Jun 2015 00:03:20 +0200

dune-istl (2.4~20150506gee6e5f6-1) experimental; urgency=medium

  * New upstream snapshot.
  * debian/copyright: Update for new upstream snapshot.
  * Add Build-Depends-Indep: graphviz for "dot".
  * (Build-)Depend on last dune-common upload.
  * Bumped Standards-Version to 3.9.6 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Wed, 06 May 2015 00:36:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: dune-istl
 Section: libs
 Priority: optional
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/dune-istl.git
@@ -9,13 +9,16 @@
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
  automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
- libdune-common-dev (>= 2.3.1)
-Build-Depends-Indep: doxygen, ghostscript, texlive-latex-extra, texlive-latex-recommended, pgf
+ libdune-common-dev (>= 2.4.0),
+ libsuitesparse-dev
+Build-Depends-Indep: doxygen, ghostscript, graphviz, texlive-latex-extra, texlive-latex-recommended, pgf
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.3.1)
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.4.0),
+ libsuitesparse-dev
+Suggests: libdune-istl-doc (= ${source:Version})
 Description: toolbox for solving PDEs -- iterative solvers (development files)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
  for solving partial differential equations (PDEs) with grid-based methods.

## dune-istl 2.4.1

=== CMakeLists.txt ===
# set up project
project("dune-istl" C CXX)

# general stuff
cmake_minimum_required(VERSION 2.8.6)

# guess build tree of dune-common
if(NOT (dune-common_DIR OR dune-common_ROOT OR
        "${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
    string(REPLACE  ${CMAKE_PROJECT_NAME} dune-common dune-common_DIR
      ${PROJECT_BINARY_DIR})

endif()

#find dune-common and set the module path
find_package(dune-common REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
  "${PROJECT_SOURCE_DIR}/cmake/modules")

#include the dune macros
include(DuneMacros)

# start a dune project with information from dune.module
dune_project()

add_subdirectory("cmake/modules")
add_subdirectory("m4")
add_subdirectory("dune")
add_subdirectory("doc")

# finalize the dune project, e.g. generating config.h etc.
finalize_dune_project(GENERATE_CONFIG_H_CMAKE)

=== doc/CMakeLists.txt ===
add_subdirectory(doxygen)

dune_add_latex_document(istl.tex
  FATHER_TARGET doc
  DEFAULT_SAFEPDF
  BIBFILES istl.bib
  IMAGES blockstructure.eps)
create_doc_install(istl.pdf
  ${CMAKE_INSTALL_DOCDIR} istl_safepdf)

=== m4/CMakeLists.txt ===
install(PROGRAMS
  dune_istl.m4 pardiso.m4 superlu-dist.m4 superlu.m4
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/aclocal)

=== cmake/modules/CMakeLists.txt ===
set(modules
  AddSuperLUFlags.cmake
  DuneIstlMacros.cmake
  FindSuperLU.cmake)

install(FILES ${modules} DESTINATION
  ${DUNE_INSTALL_MODULEDIR})

=== doc/doxygen/CMakeLists.txt ===
# shortcut for creating the Doxyfile.in and Doxyfile
add_doxygen_target()

=== dune/istl/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,6 @@
    btdmatrix.hh
    bvector.hh
    colcompmatrix.hh
-   diagonalmatrix.hh
    gsetc.hh
    ilu.hh
    ilusubdomainsolver.hh

=== dune/istl/paamg/CMakeLists.txt ===
add_subdirectory("test" EXCLUDE_FROM_ALL)

#install headers
install(FILES
  aggregates.hh
  amg.hh
  combinedfunctor.hh
  construction.hh
  dependency.hh
  fastamg.hh
  fastamgsmoother.hh
  galerkin.hh
  globalaggregates.hh
  graph.hh
  graphcreator.hh
  hierarchy.hh
  indicescoarsener.hh
  kamg.hh
  parameters.hh
  pinfo.hh
  properties.hh
  renumberer.hh
  smoother.hh
  transfer.hh
  twolevelmethod.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/istl/paamg)

=== dune/istl/test/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
 set(NORMALTEST
   basearraytest
+  bcrsassigntest
   bvectortest
   bcrsbuildtest
   bcrsimplicitbuildtest
+  complexmatrixtest
   dotproducttest
   iotest
   inverseoperator2prectest
@@ -50,7 +52,9 @@
 
 # Provide source files
 add_executable(basearraytest "basearraytest.cc")
+add_executable(bcrsassigntest "bcrsassigntest.cc")
 add_executable(dotproducttest "dotproducttest.cc")
+add_executable(complexmatrixtest "complexmatrixtest.cc")
 add_executable(matrixutilstest "matrixutilstest.cc")
 add_executable(matrixtest "matrixtest.cc")
 add_executable(bvectortest "bvectortest.cc")
@@ -120,3 +124,6 @@
   target_link_libraries(${_exe} "dunecommon")
   add_test(${_exe} ${_exe})
 endforeach(_exe ${ALLTESTS})
+
+exclude_from_headercheck(
+  complexdata.hh)

=== dune/istl/tutorial/CMakeLists.txt ===
add_executable(example "example.cc")
add_dune_mpi_flags(example)
add_dune_boost_flags(example)
target_link_libraries(example "dunecommon")

=== dune/istl/paamg/test/CMakeLists.txt ===
if(MPI_FOUND)
  set(MPITESTS  galerkintest hierarchytest transfertest pamgtest)
endif(MPI_FOUND)

if(UMFPACK_FOUND)
  set(UMFPACKTESTS umfpackfastamg umfpackamgtest)
endif(UMFPACK_FOUND)
if(SUPERLU_FOUND)
  set(SUPERLUTESTS superlufastamg superluamgtest)
endif(SUPERLU_FOUND)
if(PARMETIS_FOUND)
  set(PARMETISTESTS pamgtest pamg_comm_repart_test)
endif(PARMETIS_FOUND)
if(CMAKE_USE_PTHREADS_INIT)
  set(PTHREADTESTS pthreadamgtest pthreadfastamgtest pthreadtwoleveltest)
  if(SUPERLU_FOUND OR UMFPACK_FOUND)
    set(PTHREADTESTS ${PTHREADTESTS} pthreaddirectamgtest pthreaddirectfastamgtest pthreaddirecttwoleveltest)
  endif(SUPERLU_FOUND OR UMFPACK_FOUND)
endif(CMAKE_USE_PTHREADS_INIT)
set(NORMALTESTS amgtest fastamg graphtest kamgtest twolevelmethodschwarztest twolevelmethodtest ${PTHREADTESTS})
set(ALLTESTS ${MPITESTS} ${PARMETISTESTS} ${NORMALTESTS} ${UMFPACKTESTS} ${SUPERLUTESTS})

# We do not want want to build the tests during make all,
# but just build them on demand
add_directory_test_target(_test_target)
add_dependencies(${_test_target} ${ALLTESTS})

find_package(Threads)
if(CMAKE_USE_PTHREADS_INIT)
  # test: pthreadamgtest
  add_executable(pthreadamgtest pthreadamgtest.cc)
  set_property(TARGET pthreadamgtest APPEND PROPERTY
    COMPILE_DEFINITIONS "MYAMG=Dune::Amg::AMG<Operator,Vector,Smoother>")
  target_link_libraries(pthreadamgtest "${CMAKE_THREAD_LIBS_INIT}")
  # test: pthreadfastamgtest
  add_executable(pthreadfastamgtest pthreadamgtest.cc)
  set_property(TARGET pthreadfastamgtest APPEND PROPERTY
    COMPILE_DEFINITIONS "MYAMG=Dune::Amg::FastAMG<Operator,Vector>")
  target_link_libraries(pthreadfastamgtest "${CMAKE_THREAD_LIBS_INIT}")
  # test: pthreadtwoleveltest
  add_executable(pthreadtwoleveltest pthreadtwoleveltest.cc)
  target_link_libraries(pthreadtwoleveltest "${CMAKE_THREAD_LIBS_INIT}")
  if(SUPERLU_FOUND OR UMFPACK_FOUND)
    # test: pthreaddirectamgtest
    add_executable(pthreaddirectamgtest pthreadamgtest.cc)
    set_property(TARGET pthreaddirectamgtest APPEND PROPERTY
      COMPILE_DEFINITIONS "MYAMG=Dune::Amg::AMG<Operator,Vector,Smoother>")
    target_link_libraries(pthreaddirectamgtest "${CMAKE_THREAD_LIBS_INIT}")
    # test: pthreaddirectfastamgtest
    add_executable(pthreaddirectfastamgtest pthreadamgtest.cc)
    set_property(TARGET pthreaddirectfastamgtest APPEND PROPERTY
      COMPILE_DEFINITIONS "MYAMG=Dune::Amg::FastAMG<Operator,Vector>")
    target_link_libraries(pthreaddirectfastamgtest "${CMAKE_THREAD_LIBS_INIT}")
    #test: pthreaddirecttwoleveltest
    add_executable(pthreaddirecttwoleveltest pthreadtwoleveltest.cc)
    target_link_libraries(pthreaddirecttwoleveltest "${CMAKE_THREAD_LIBS_INIT}")
    # add direct solver flags
    if(HAVE_SUPERLU)
      add_dune_superlu_flags(pthreaddirectamgtest pthreadfastamgtest pthreaddirecttwoleveltest)
    endif(HAVE_SUPERLU)
    if(HAVE_UMFPACK)
      add_dune_umfpack_flags(pthreaddirectamgtest pthreadfastamgtest pthreaddirecttwoleveltest)
    endif(HAVE_UMFPACK)
  endif(SUPERLU_FOUND OR UMFPACK_FOUND)
endif(CMAKE_USE_PTHREADS_INIT)

add_executable(amgtest "amgtest.cc")
add_executable(fastamg "fastamg.cc")
if(SUPERLU_FOUND)
  add_executable(superluamgtest "amgtest.cc")
  add_dune_superlu_flags(superluamgtest)
  add_executable(superlufastamg "fastamg.cc")
  add_dune_superlu_flags(superlufastamg)
endif(SUPERLU_FOUND)
if(UMFPACK_FOUND)
  add_executable(umfpackamgtest "amgtest.cc")
  add_dune_umfpack_flags(umfpackamgtest)
  add_executable(umfpackfastamg "fastamg.cc")
  add_dune_umfpack_flags(umfpackfastamg)
endif(UMFPACK_FOUND)
add_executable(twolevelmethodtest "twolevelmethodtest.cc")
add_dune_superlu_flags(twolevelmethodtest)
add_executable(galerkintest "galerkintest.cc")
add_executable(graphtest "graphtest.cc")
add_executable(hierarchytest "hierarchytest.cc")
add_executable(kamgtest "kamgtest.cc")
add_dune_superlu_flags(kamgtest)
add_executable(pamg_comm_repart_test "parallelamgtest.cc")
set_target_properties(pamg_comm_repart_test PROPERTIES COMPILE_FLAGS "-DAMG_REPART_ON_COMM_GRAPH")
add_executable(pamgtest "parallelamgtest.cc")
add_dune_superlu_flags(pamgtest)
add_executable(transfertest "transfertest.cc")
add_executable(twolevelmethodschwarztest "twolevelmethodtest.cc")
set_target_properties(twolevelmethodschwarztest PROPERTIES COMPILE_FLAGS "-DUSE_OVERLAPPINGSCHWARZ")
add_dune_superlu_flags(twolevelmethodschwarztest)

foreach(_exe ${ALLTESTS})
  target_link_libraries(${_exe} "dunecommon")
  add_test(${_exe} ${_exe})
endforeach(_exe ${ALLTESTS})

add_dune_mpi_flags("${MPITESTS}")
add_dune_parmetis_flags("${PARMETISTESTS}")

=== debian/changelog ===
dune-istl (2.4.1-1) unstable; urgency=medium

  * New upstream release.
  * (Build-)Depend on last dune-common upload.

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 29 Feb 2016 10:28:13 +0100

dune-istl (2.4.1~rc2-1) experimental; urgency=medium

  * New upstream release candidate.
  * (Build-)Depend on last dune-common upload.
  * Mark packages as Multi-Arch: foreign.
  * debian/control: Update Vcs-* fields.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 28 Feb 2016 14:19:01 +0100

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,20 @@
 Standards-Version: 3.9.6
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/dune-istl.git
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/dune-istl.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-istl.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/dune-istl.git
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
  automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
- libdune-common-dev (>= 2.4.0),
+ libdune-common-dev (>= 2.4.1),
  libsuitesparse-dev
 Build-Depends-Indep: doxygen, ghostscript, graphviz, texlive-latex-extra, texlive-latex-recommended, pgf
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.4.0),
+Multi-Arch: foreign
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.4.1),
  libsuitesparse-dev
 Suggests: libdune-istl-doc (= ${source:Version})
 Description: toolbox for solving PDEs -- iterative solvers (development files)
@@ -31,6 +32,7 @@
 Package: libdune-istl-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: toolbox for solving PDEs -- iterative solvers (documentation)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox

## dune-istl 2.5.0

=== debian/changelog ===
dune-istl (2.5.0-2) unstable; urgency=medium

  * Use correct type for second template argument of `std::array`.
    (Closes: #860666)
    + patch: 0001-Merge-branch-bugfix-build-failure-on-i386-into-maste.patch

 -- Ansgar Burchardt <ansgar@debian.org>  Thu, 20 Apr 2017 19:36:09 +0200

dune-istl (2.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 18 Dec 2016 13:24:43 +0100

dune-istl (2.5.0~rc2-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release candidate.

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 05 Dec 2016 23:29:29 +0100

dune-istl (2.5.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * (Build-)Depend on last dune-common upload.
  * Switch to CMake.
  * Bumped Standards-Version to 3.9.8 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 21 Nov 2016 20:43:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,23 @@
 Source: dune-istl
 Section: libs
 Priority: optional
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-istl.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/dune-istl.git
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
- automake, autoconf, gfortran, libtool, mpi-default-bin, mpi-default-dev, pkg-config,
- libdune-common-dev (>= 2.4.1),
+ cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
+ libdune-common-dev (>= 2.5.0),
  libsuitesparse-dev
-Build-Depends-Indep: doxygen, ghostscript, graphviz, texlive-latex-extra, texlive-latex-recommended, pgf
+Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, pgf
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.4.1),
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.5.0),
  libsuitesparse-dev
 Suggests: libdune-istl-doc (= ${source:Version})
 Description: toolbox for solving PDEs -- iterative solvers (development files)

## dune-istl 2.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # set up project
-project("dune-istl" C CXX)
+project(dune-istl C CXX)
 
 # general stuff
-cmake_minimum_required(VERSION 2.8.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 # guess build tree of dune-common
 if(NOT (dune-common_DIR OR dune-common_ROOT OR
@@ -23,10 +23,10 @@
 # start a dune project with information from dune.module
 dune_project()
 
-add_subdirectory("cmake/modules")
-add_subdirectory("m4")
-add_subdirectory("dune")
-add_subdirectory("doc")
+add_subdirectory(cmake/modules)
+add_subdirectory(dune)
+add_subdirectory(doc)
+add_subdirectory(lib)
 
 # finalize the dune project, e.g. generating config.h etc.
 finalize_dune_project(GENERATE_CONFIG_H_CMAKE)

=== doc/CMakeLists.txt ===
add_subdirectory(doxygen)

dune_add_latex_document(istl.tex
  FORCE_DVI
  BIBFILES istl.bib
  IMAGES blockstructure.eps)
create_doc_install(istl.pdf
  ${CMAKE_INSTALL_DOCDIR} istl_safepdf)

=== dune/istl/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
+add_subdirectory("eigenvalue")
 add_subdirectory("paamg")
 add_subdirectory("tutorial")
-add_subdirectory("test" EXCLUDE_FROM_ALL)
+add_subdirectory(test)
 
 #install headers
 install(FILES
@@ -15,6 +16,7 @@
    ilusubdomainsolver.hh
    io.hh
    istlexception.hh
+   ldl.hh
    matrix.hh
    matrixindexset.hh
    matrixmarket.hh
@@ -38,6 +40,7 @@
    solver.hh
    solvers.hh
    solvertype.hh
+   spqr.hh
    superlu.hh
    supermatrix.hh
    umfpack.hh

=== dune/istl/test/CMakeLists.txt ===
# install the test tools as we want to support testing 3rd-party vectors with an installed dune-istl
install(FILES vectortest.hh
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/istl/test)

dune_add_test(SOURCES basearraytest.cc)

dune_add_test(SOURCES bcrsassigntest.cc)

dune_add_test(SOURCES bcrsnormtest.cc)

dune_add_test(SOURCES dotproducttest.cc)

dune_add_test(SOURCES complexmatrixtest.cc)

dune_add_test(SOURCES fieldvectortest.cc)

dune_add_test(SOURCES matrixnormtest.cc)

dune_add_test(SOURCES matrixutilstest.cc)

dune_add_test(SOURCES matrixtest.cc)

dune_add_test(SOURCES bvectortest.cc)

dune_add_test(SOURCES vbvectortest.cc)

dune_add_test(SOURCES bcrsbuild.cc)

dune_add_test(SOURCES bcrsimplicitbuild.cc
              COMPILE_DEFINITIONS DUNE_ISTL_WITH_CHECKING=1)

dune_add_test(SOURCES matrixiteratortest.cc)

dune_add_test(SOURCES mmtest.cc)

dune_add_test(SOURCES multitypeblockmatrixtest.cc)

dune_add_test(SOURCES multitypeblockvectortest.cc)

dune_add_test(SOURCES mv.cc)

dune_add_test(SOURCES iotest.cc)

dune_add_test(SOURCES inverseoperator2prectest.cc)

dune_add_test(SOURCES scaledidmatrixtest.cc)

dune_add_test(SOURCES solvertest.cc)

dune_add_test(SOURCES solveraborttest.cc)

# Pardiso tests
dune_add_test(SOURCES test_pardiso.cc)

# SuperLU tests
dune_add_test(NAME superlustest
              SOURCES superlutest.cc
              COMPILE_DEFINITIONS SUPERLU_NTYPE=0)

dune_add_test(SOURCES superlutest.cc)

dune_add_test(NAME superluctest
              SOURCES superlutest.cc
              COMPILE_DEFINITIONS SUPERLU_NTYPE=2)

dune_add_test(NAME superluztest
              SOURCES superlutest.cc
              COMPILE_DEFINITIONS SUPERLU_NTYPE=3)

dune_add_test(SOURCES complexrhstest.cc
              COMPILE_DEFINITIONS SUPERLU_NTYPE=3)

# SuiteSparse tests
dune_add_test(SOURCES umfpacktest.cc)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "umfpack_decomp")

dune_add_test(SOURCES ldltest.cc)

dune_add_test(SOURCES spqrtest.cc)

dune_add_test(SOURCES overlappingschwarztest.cc)

# MPI tests
dune_add_test(SOURCES matrixredisttest.cc
              CMAKE_GUARD MPI_FOUND)

dune_add_test(SOURCES vectorcommtest.cc
              CMAKE_GUARD MPI_FOUND)

dune_add_test(SOURCES matrixmarkettest.cc)

exclude_from_headercheck(complexdata.hh)

=== debian/changelog ===
dune-istl (2.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Build-Depend on texlive-pictures instead of pgf. (Closes: #867078)
  * debian/copyright: Update URLs.
  * Bumped Standards-Version to 4.0.0 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 18 Jul 2017 12:01:32 +0200

dune-istl (2.5.1~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * Remove patch (applied upstream).

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 17 Jun 2017 17:04:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: dune-istl
 Section: libs
 Priority: optional
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-istl.git
@@ -9,15 +9,15 @@
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
  cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
- libdune-common-dev (>= 2.5.0),
+ libdune-common-dev (>= 2.5.1),
  libsuitesparse-dev
-Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, pgf
+Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, texlive-pictures
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.5.0),
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.5.1),
  libsuitesparse-dev
 Suggests: libdune-istl-doc (= ${source:Version})
 Description: toolbox for solving PDEs -- iterative solvers (development files)

## dune-istl 2.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(dune-istl C CXX)
 
 # general stuff
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.1)
 
 # guess build tree of dune-common
 if(NOT (dune-common_DIR OR dune-common_ROOT OR

=== dune/CMakeLists.txt ===
add_subdirectory(istl)

=== cmake/modules/CMakeLists.txt ===
set(modules
  AddARPACKPPFlags.cmake
  AddSuperLUFlags.cmake
  DuneIstlMacros.cmake
  FindARPACK.cmake
  FindARPACKPP.cmake
  FindSuperLU.cmake)

install(FILES ${modules} DESTINATION
  ${DUNE_INSTALL_MODULEDIR})

=== dune/istl/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 
 #install headers
 install(FILES
+   allocator.hh
    basearray.hh
    bcrsmatrix.hh
    bdmatrix.hh
@@ -12,6 +13,7 @@
    bvector.hh
    colcompmatrix.hh
    gsetc.hh
+   ildl.hh
    ilu.hh
    ilusubdomainsolver.hh
    io.hh
@@ -42,6 +44,7 @@
    solvertype.hh
    spqr.hh
    superlu.hh
+   superlufunctions.hh
    supermatrix.hh
    umfpack.hh
    vbvector.hh

=== dune/istl/eigenvalue/CMakeLists.txt ===
add_subdirectory(test)

#install headers
install(FILES
   arpackpp.hh
   poweriteration.hh
   DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/istl/eigenvalue)

=== dune/istl/paamg/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-add_subdirectory("test" EXCLUDE_FROM_ALL)
+add_subdirectory(test)
 
 #install headers
 install(FILES

=== dune/istl/test/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,8 @@
 dune_add_test(SOURCES bcrsassigntest.cc)
 
 dune_add_test(SOURCES bcrsnormtest.cc)
+
+dune_add_test(SOURCES cgconditiontest.cc)
 
 dune_add_test(SOURCES dotproducttest.cc)
 
@@ -19,6 +21,9 @@
 dune_add_test(SOURCES matrixutilstest.cc)
 
 dune_add_test(SOURCES matrixtest.cc)
+
+dune_add_test(SOURCES multirhstest.cc)
+  add_dune_vc_flags(multirhstest)
 
 dune_add_test(SOURCES bvectortest.cc)
 
@@ -49,36 +54,33 @@
 
 dune_add_test(SOURCES solveraborttest.cc)
 
-# Pardiso tests
-dune_add_test(SOURCES test_pardiso.cc)
+# SuperLU tests
+  dune_add_test(NAME superlustest
+                SOURCES superlutest.cc
+                COMPILE_DEFINITIONS SUPERLU_NTYPE=0)
 
-# SuperLU tests
-dune_add_test(NAME superlustest
-              SOURCES superlutest.cc
-              COMPILE_DEFINITIONS SUPERLU_NTYPE=0)
+  dune_add_test(SOURCES superlutest.cc)
 
-dune_add_test(SOURCES superlutest.cc)
+  dune_add_test(NAME superluctest
+                SOURCES superlutest.cc
+                COMPILE_DEFINITIONS SUPERLU_NTYPE=2)
 
-dune_add_test(NAME superluctest
-              SOURCES superlutest.cc
-              COMPILE_DEFINITIONS SUPERLU_NTYPE=2)
+  dune_add_test(NAME superluztest
+                SOURCES superlutest.cc
+                COMPILE_DEFINITIONS SUPERLU_NTYPE=3)
 
-dune_add_test(NAME superluztest
-              SOURCES superlutest.cc
-              COMPILE_DEFINITIONS SUPERLU_NTYPE=3)
-
-dune_add_test(SOURCES complexrhstest.cc
-              COMPILE_DEFINITIONS SUPERLU_NTYPE=3)
+  dune_add_test(SOURCES complexrhstest.cc
+                COMPILE_DEFINITIONS SUPERLU_NTYPE=3)
 
 # SuiteSparse tests
-dune_add_test(SOURCES umfpacktest.cc)
-set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "umfpack_decomp")
+  dune_add_test(SOURCES umfpacktest.cc)
+  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "umfpack_decomp")
 
 dune_add_test(SOURCES ldltest.cc)
 
 dune_add_test(SOURCES spqrtest.cc)
 
-dune_add_test(SOURCES overlappingschwarztest.cc)
+  dune_add_test(SOURCES overlappingschwarztest.cc)
 
 # MPI tests
 dune_add_test(SOURCES matrixredisttest.cc
@@ -87,6 +89,8 @@
 dune_add_test(SOURCES vectorcommtest.cc
               CMAKE_GUARD MPI_FOUND)
 
-dune_add_test(SOURCES matrixmarkettest.cc)
+  dune_add_test(SOURCES matrixmarkettest.cc)
+
+dune_add_test(SOURCES iluildltest.cc)
 
 exclude_from_headercheck(complexdata.hh)

=== dune/istl/tutorial/CMakeLists.txt ===
add_executable(example "example.cc")
add_dune_mpi_flags(example)
target_link_libraries(example "dunecommon")

=== dune/istl/eigenvalue/test/CMakeLists.txt ===
add_executable(poweriterationtest cond2test.cc)
target_link_libraries(poweriterationtest dunecommon)
dune_add_test(
  TARGET poweriterationtest
  CMD_ARGS 40)

if(SUPERLU_FOUND)
  add_executable(poweriterationsuperlutest cond2test.cc)
  add_dune_superlu_flags(poweriterationsuperlutest)
  dune_add_test(
    TARGET poweriterationsuperlutest
    CMD_ARGS 40)
  target_link_libraries(poweriterationsuperlutest dunecommon)
endif()

if(ARPACKPP_FOUND)
  add_executable(arpackpptest cond2test.cc)
  add_dune_arpackpp_flags(arpackpptest)
  target_link_libraries(arpackpptest dunecommon)
  dune_add_test(TARGET arpackpptest)
endif()

if(ARPACKPP_FOUND AND SUPERLU_FOUND)
  dune_add_test(NAME arpackppsuperlutest
                SOURCES cond2test.cc)
endif()

=== dune/istl/paamg/test/CMakeLists.txt ===
find_package(Threads)
if(CMAKE_USE_PTHREADS_INIT)
  add_executable(pthreadamgtest pthreadamgtest.cc)
  target_compile_definitions(pthreadamgtest PUBLIC MYAMG=Dune::Amg::AMG<Operator,Vector,Smoother>)
  target_link_libraries(pthreadamgtest ${CMAKE_THREAD_LIBS_INIT} ${DUNE_LIBS})
  dune_add_test(TARGET pthreadamgtest)

  add_executable(pthreadfastamgtest pthreadamgtest.cc)
  target_compile_definitions(pthreadfastamgtest PUBLIC MYAMG=Dune::Amg::FastAMG<Operator,Vector>)
  add_dune_mpi_flags(pthreadfastamgtest)
  target_link_libraries(pthreadfastamgtest ${CMAKE_THREAD_LIBS_INIT} ${DUNE_LIBS})
  dune_add_test(TARGET pthreadfastamgtest)

  add_executable(pthreadtwoleveltest pthreadtwoleveltest.cc)
  target_link_libraries(pthreadtwoleveltest ${CMAKE_THREAD_LIBS_INIT} ${DUNE_LIBS})
  dune_add_test(TARGET pthreadtwoleveltest)

  dune_add_test(NAME pthreaddirectamgtest
                SOURCES pthreadamgtest.cc
                COMPILE_DEFINITIONS MYAMG=Dune::Amg::AMG<Operator,Vector,Smoother>
                LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
                CMAKE_GUARD "SUPERLU_FOUND OR SuiteSparse_UMFPACK_FOUND")

  dune_add_test(NAME pthreaddirectfastamgtest
                SOURCES pthreadamgtest.cc
                COMPILE_DEFINITIONS MYAMG=Dune::Amg::FastAMG<Operator,Vector>
                LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
                CMAKE_GUARD "SUPERLU_FOUND OR SuiteSparse_UMFPACK_FOUND")

  dune_add_test(NAME pthreaddirecttwoleveltest
                SOURCES pthreadtwoleveltest.cc
                LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
                CMAKE_GUARD "SUPERLU_FOUND OR SuiteSparse_UMFPACK_FOUND")
endif()

# add an executable without SuperLU/UMFPack
add_executable(amgtest amgtest.cc)
target_link_libraries(amgtest ${DUNE_LIBS})
dune_add_test(TARGET amgtest)

add_executable(fastamg fastamg.cc)
target_link_libraries(fastamg ${DUNE_LIBS})
dune_add_test(TARGET fastamg)

if(SUPERLU_FOUND)
  add_executable(superluamgtest amgtest.cc)
  add_dune_superlu_flags(superluamgtest)
  target_link_libraries(superluamgtest ${DUNE_LIBS})
  dune_add_test(TARGET superluamgtest)

  add_executable(superlufastamgtest fastamg.cc)
  add_dune_superlu_flags(superlufastamgtest)
  target_link_libraries(superlufastamgtest ${DUNE_LIBS})
  dune_add_test(TARGET superlufastamgtest)
endif()

dune_add_test(NAME umfpackamgtest
              SOURCES amgtest.cc
              CMAKE_GUARD SuiteSparse_UMFPACK_FOUND)

dune_add_test(NAME umfpackfastamgtest
              SOURCES fastamg.cc
              CMAKE_GUARD SuiteSparse_UMFPACK_FOUND)

dune_add_test(SOURCES twolevelmethodtest.cc)

dune_add_test(SOURCES graphtest.cc)

dune_add_test(SOURCES kamgtest.cc)

dune_add_test(SOURCES transfertest.cc)

dune_add_test(NAME twolevelmethodschwarztest
              SOURCES twolevelmethodtest.cc
              COMPILE_DEFINITIONS USE_OVERLAPPINGSCHWARZ)

# These tests need MPI, even though they are only run sequentially
dune_add_test(SOURCES galerkintest.cc
              CMAKE_GUARD MPI_FOUND)

dune_add_test(SOURCES hierarchytest.cc
              CMAKE_GUARD MPI_FOUND)

dune_add_test(NAME pamgtest
              SOURCES parallelamgtest.cc
              CMAKE_GUARD MPI_FOUND)

dune_add_test(NAME pamg_comm_repart_test
              SOURCES parallelamgtest.cc
              COMPILE_DEFINITIONS -DAMG_REPART_ON_COMM_GRAPH
              CMAKE_GUARD MPI_FOUND)

=== debian/changelog ===
dune-istl (2.6.0-2) unstable; urgency=medium

  * backport patches to fix compiler error and warnings with GCC 8.
    (Closes: #906351)
    + new patch: 0001-CompPair-make-operator-a-const-method.patch
    + new patch: 0002-do-not-catch-polymorphic-types-by-value.patch
    + new patch: 0003-silence-warnings-about-unused-variables.patch

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 28 Sep 2018 21:05:16 +0200

dune-istl (2.6.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control: now requires cmake >= 3.1

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 03 Apr 2018 00:31:44 +0200

dune-istl (2.6.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * add (Build-)Depends: libsuperlu-dev
  * d/control: update Vcs-* fields for move to salsa.debian.org
  * Bumped Standards-Version to 4.1.3 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 06 Jan 2018 19:12:54 +0100

dune-istl (2.6~20171113-1) experimental; urgency=medium

  * New upstream snapshot.
  * d/control: add `Rules-Requires-Root: no`
  * libdune-istl-doc: add Built-Using: doxygen (for jquery.js)
  * Bumped Standards-Version to 4.1.1 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Wed, 15 Nov 2017 09:18:33 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,27 @@
 Source: dune-istl
 Section: libs
 Priority: optional
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-istl.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/dune-istl.git
+Vcs-Browser: https://salsa.debian.org/science-team/dune-istl
+Vcs-Git: https://salsa.debian.org/science-team/dune-istl.git
 Homepage: http://www.dune-project.org/
 Build-Depends: debhelper (>= 9),
- cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
- libdune-common-dev (>= 2.5.1),
- libsuitesparse-dev
+ cmake (>= 3.1), gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
+ libdune-common-dev (>= 2.6.0),
+ libsuitesparse-dev,
+ libsuperlu-dev
 Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, texlive-pictures
+Rules-Requires-Root: no
 
 Package: libdune-istl-dev
 Section: libdevel
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, libdune-common-dev (>= 2.5.1),
- libsuitesparse-dev
+Depends: ${misc:Depends}, libdune-common-dev (>= 2.6.0),
+ libsuitesparse-dev,
+ libsuperlu-dev
 Suggests: libdune-istl-doc (= ${source:Version})
 Description: toolbox for solving PDEs -- iterative solvers (development files)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
@@ -34,6 +37,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
+Built-Using: ${dune:doc:Built-Using}
 Description: toolbox for solving PDEs -- iterative solvers (documentation)
  DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
  for solving partial differential equations (PDEs) with grid-based methods.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dune/dune-debian.mk

%:
	dh $@ --parallel --builddirectory=build
